const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CampaignsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const campaigns = await db.campaigns.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        spend: data.spend || null,
        impressions: data.impressions || null,
        clicks: data.clicks || null,
        conversions: data.conversions || null,
        cpa: data.cpa || null,
        ctr_pct: data.ctr_pct || null,
        status: data.status || null,
        start_date: data.start_date || null,
        end_date: data.end_date || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await campaigns.setOrganization(currentUser.organization.id || null, {
      transaction,
    });

    await campaigns.setOrganizations(data.organizations || null, {
      transaction,
    });

    return campaigns;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const campaignsData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      spend: item.spend || null,
      impressions: item.impressions || null,
      clicks: item.clicks || null,
      conversions: item.conversions || null,
      cpa: item.cpa || null,
      ctr_pct: item.ctr_pct || null,
      status: item.status || null,
      start_date: item.start_date || null,
      end_date: item.end_date || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const campaigns = await db.campaigns.bulkCreate(campaignsData, {
      transaction,
    });

    // For each item created, replace relation files

    return campaigns;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const campaigns = await db.campaigns.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.spend !== undefined) updatePayload.spend = data.spend;

    if (data.impressions !== undefined)
      updatePayload.impressions = data.impressions;

    if (data.clicks !== undefined) updatePayload.clicks = data.clicks;

    if (data.conversions !== undefined)
      updatePayload.conversions = data.conversions;

    if (data.cpa !== undefined) updatePayload.cpa = data.cpa;

    if (data.ctr_pct !== undefined) updatePayload.ctr_pct = data.ctr_pct;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.start_date !== undefined)
      updatePayload.start_date = data.start_date;

    if (data.end_date !== undefined) updatePayload.end_date = data.end_date;

    updatePayload.updatedById = currentUser.id;

    await campaigns.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await campaigns.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await campaigns.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return campaigns;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const campaigns = await db.campaigns.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of campaigns) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of campaigns) {
        await record.destroy({ transaction });
      }
    });

    return campaigns;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const campaigns = await db.campaigns.findByPk(id, options);

    await campaigns.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await campaigns.destroy({
      transaction,
    });

    return campaigns;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const campaigns = await db.campaigns.findOne({ where }, { transaction });

    if (!campaigns) {
      return campaigns;
    }

    const output = campaigns.get({ plain: true });

    output.organization = await campaigns.getOrganization({
      transaction,
    });

    output.organizations = await campaigns.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('campaigns', 'name', filter.name),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              start_date: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              end_date: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.spendRange) {
        const [start, end] = filter.spendRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            spend: {
              ...where.spend,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            spend: {
              ...where.spend,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.impressionsRange) {
        const [start, end] = filter.impressionsRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            impressions: {
              ...where.impressions,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            impressions: {
              ...where.impressions,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.clicksRange) {
        const [start, end] = filter.clicksRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            clicks: {
              ...where.clicks,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            clicks: {
              ...where.clicks,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.conversionsRange) {
        const [start, end] = filter.conversionsRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            conversions: {
              ...where.conversions,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            conversions: {
              ...where.conversions,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.cpaRange) {
        const [start, end] = filter.cpaRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            cpa: {
              ...where.cpa,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            cpa: {
              ...where.cpa,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.ctr_pctRange) {
        const [start, end] = filter.ctr_pctRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ctr_pct: {
              ...where.ctr_pct,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ctr_pct: {
              ...where.ctr_pct,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.start_dateRange) {
        const [start, end] = filter.start_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            start_date: {
              ...where.start_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            start_date: {
              ...where.start_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.end_dateRange) {
        const [start, end] = filter.end_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            end_date: {
              ...where.end_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            end_date: {
              ...where.end_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.campaigns.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('campaigns', 'name', query),
        ],
      };
    }

    const records = await db.campaigns.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
